#
# MVFX : Music Visual Effects (tentative name)
#
# Rev. 0.02   April 6, 2008 by zhuo  http://geocities.yahoo.co.jp/gl/zhuoware
# Rev. 0.05   May 3, 2008 by zhuo  http://geocities.yahoo.co.jp/gl/zhuoware



######################################################################
# package dependencies
######################################################################
package require snack 2.2


######################################################################
# global constants
######################################################################
set MVFXSysAttr(MVFXVersion) "0.05"


######################################################################
# VIEWER SECTION
######################################################################
set MVFXVizAttr(mainW) 2048
set MVFXVizAttr(mainH) 1024
set MVFXVizAttr(mainWinH) 320


set MVFXVizAttr(panelWinW) 320
set MVFXVizAttr(panelLeft) 0
set MVFXVizAttr(panelRight) 480
set MVFXVizAttr(panelTop) 0
set MVFXVizAttr(panelBottom) $MVFXVizAttr(mainH)
set MVFXVizAttr(panelBGColor) black
set MVFXVizAttr(panelFont) {Ariel 9}

set MVFXVizAttr(scaleWinH) 20
set MVFXVizAttr(scaleLeft) 0
set MVFXVizAttr(scaleRight) $MVFXVizAttr(mainW)
set MVFXVizAttr(scaleTop) 0
set MVFXVizAttr(scaleBottom) $MVFXVizAttr(scaleWinH)
set MVFXVizAttr(scaleTickTall) 7
set MVFXVizAttr(scaleTickShort) 4
set MVFXVizAttr(scaleBGColor) "\#404040"
set MVFXVizAttr(scaleFGColor) white
set MVFXVizAttr(scaleFont) {Ariel 8}

set MVFXVizAttr(dispLeft) 0
set MVFXVizAttr(dispTop) 0
set MVFXVizAttr(dispRight) $MVFXVizAttr(mainW)
set MVFXVizAttr(dispBottom) $MVFXVizAttr(mainH)

set MVFXVizAttr(dispWinW) 640
set MVFXVizAttr(dispBackGroundColor) black

set MVFXVizAttr(dispWaveformFillColor) yellow
set MVFXVizAttr(dispWaveformHeightPixel) 96
set MVFXVizAttr(dispWaveformSubsample) 24
set MVFXVizAttr(dispPixelsPerSecond) 240
#set MVFXVizAttr(dispWaveformSubsample) 100
#set MVFXVizAttr(dispPixelsPerSecond) 60

set MVFXVizAttr(dispSpectrogramHeightPixel) 360
set MVFXVizAttr(dispSpectrogramGridColor) yellow
set MVFXVizAttr(dispSpectrogramTopFreq) 1600
#set MVFXVizAttr(dispSpectrogramGridFSpacing) 
#set MVFXVizAttr(dispSpectrogramGridTSpacing) 

set MVFXVizAttr(dispSpectrogramFFTLength) 4096

set MVFXVizAttr(dispHorizScaleMode) second
#set MVFXVizAttr(dispScaleMode) sample
#set MVFXVizAttr(dispScaleMode) beat

set MVFXVizAttr(dispHorizScaleBGColor) "\#484848"
set MVFXVizAttr(dispHorizScaleHeight) 12

########################################
# 
########################################




########################################
# toplevel window
########################################
set w .top
catch {destroy $w}
toplevel $w
wm title $w "MVFX Rev.$MVFXSysAttr(MVFXVersion)"
wm iconname $w "MVFX Rev.$MVFXSysAttr(MVFXVersion)"
wm withdraw .



########################################
# menu bar
########################################
set menustatus "  "

menu $w.menu -tearoff 0

set mFile $w.menu.file
menu $mFile -tearoff 0
$mFile add command -label "Open Sound File..." -command {MVFXCmdLoadSound $w}
$mFile add separator
$mFile add command -label "Exit" -command "destroy $w; exit 0"

set mEdit $w.menu.edit
menu $mEdit -tearoff 0
$mEdit add command -label "Play" -command {playbackVsd}

$w.menu add cascade -label "File" -menu $mFile -underline 0
$w.menu add cascade -label "Edit" -menu $mEdit -underline 0
$w configure -menu $w.menu

bind Menu <<MenuSelect>> {
    global $menustatus
    if {[catch {%W entrycget active -label} label]} {
	set label "    "
    }
    set menustatus $label
    update idletasks
}

bind $w "q" {destroy $w; exit 0}



########################################
# main screen : left-side (panel), right-side(disp)
########################################

#
# tag rules
#
# horizontal scale :    horizScale
# the waveform object :  "snd0" "snd1" ...

frame $w.cframe
canvas $w.cframe.panel \
    -scrollregion \
        "$MVFXVizAttr(panelLeft) $MVFXVizAttr(panelTop) $MVFXVizAttr(panelRight) $MVFXVizAttr(panelBottom)" \
    -width $MVFXVizAttr(panelWinW) \
    -height $MVFXVizAttr(mainWinH) \
    -xscrollcommand "$w.cframe.panelhscroll set" \
    -yscrollcommand "$w.cframe.vscroll set" \
    -background $MVFXVizAttr(panelBGColor) \
    -relief sunken

canvas $w.cframe.scale \
    -width $MVFXVizAttr(mainWinH) \
    -height $MVFXVizAttr(scaleWinH) \
    -xscrollcommand "$w.cframe.disphscroll set" \
    -background $MVFXVizAttr(scaleBGColor) 

canvas $w.cframe.disp \
    -scrollregion "$MVFXVizAttr(dispLeft) $MVFXVizAttr(dispTop) $MVFXVizAttr(dispRight) $MVFXVizAttr(dispBottom)" \
    -width $MVFXVizAttr(dispWinW) \
    -height $MVFXVizAttr(mainWinH) \
    -xscrollcommand "$w.cframe.disphscroll set" \
    -yscrollcommand "$w.cframe.vscroll set" \
    -background $MVFXVizAttr(dispBackGroundColor) \
    -relief sunken

scrollbar $w.cframe.panelhscroll -orient horiz -command "$w.cframe.panel xview"
scrollbar $w.cframe.disphscroll -orient horiz -command "dispHScrollCmd $w"
proc dispHScrollCmd {w args} {
    eval $w.cframe.disp xview $args
    eval $w.cframe.scale xview $args
}
scrollbar $w.cframe.vscroll -command "dispVScrollCmd $w"
proc dispVScrollCmd {w args} {
    eval $w.cframe.panel yview $args
    eval $w.cframe.disp yview $args
}


grid $w.cframe.scale -in $w.cframe \
    -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news

grid $w.cframe.panel -in $w.cframe \
    -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
grid $w.cframe.disp -in $w.cframe \
    -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
grid $w.cframe.vscroll \
    -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news

grid $w.cframe.panelhscroll \
    -row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news
grid $w.cframe.disphscroll \
    -row 2 -column 1 -rowspan 1 -columnspan 1 -sticky news

grid rowconfig $w.cframe 0 -weight 0
grid rowconfig $w.cframe 2 -weight 0
grid columnconfig $w.cframe 0 -weight 0
grid columnconfig $w.cframe 1 -weight 1
grid columnconfig $w.cframe 2 -weight 0
pack $w.cframe -side top -fill both -expand yes



########################################
# debug console
########################################
if { 1 } {
    text $w.cons -width 80 -height 12
    pack $w.cons -side top -fill both -expand yes
}

proc consPuts {string} {
    global w
    catch {$w.cons insert end "$string"}
}


########################################
# dialogs
########################################

proc MVFXDialogChooseSoundFile { w } {
    set types {
	{"Sound Files"	{.wav .mp3 .au .snd .aif .sd .smp .csl} }
    }
    return [tk_getOpenFile -filetypes $types -parent $w]
}


proc MVFXMenuForWaveform { w sndHdl } {
    $w.cframe.disp menu 
}




########################################
# visualizer
########################################


proc MVFXVizUpdateMainW { w widthPixel } {
    global MVFXVizAttr 

    set MVFXVizAttr(dispRight) $widthPixel
    catch {$w.cframe.disp configure -scrollregion \
	       "$MVFXVizAttr(dispLeft) $MVFXVizAttr(dispTop) $MVFXVizAttr(dispRight) $MVFXVizAttr(dispBottom)"}
    set MVFXVizAttr(scaleRight) $widthPixel
    catch {$w.cframe.scale configure -scrollregion \
	       "$MVFXVizAttr(scaleLeft) $MVFXVizAttr(scaleTop) $MVFXVizAttr(scaleRight) $MVFXVizAttr(scaleBottom)"}

    MVFXVizSetHorizScale $w
}


proc MVFXVizSetHorizScale { w } {
    global MVFXVizAttr 
    set pixPerSec $MVFXVizAttr(dispPixelsPerSecond)
    set pixMax $MVFXVizAttr(dispRight)
    set tickTallY [expr $MVFXVizAttr(scaleWinH) - $MVFXVizAttr(scaleTickTall)]
    set tickShortY [expr $MVFXVizAttr(scaleWinH) - $MVFXVizAttr(scaleTickShort)]
    consPuts "$pixMax\n"

    $w.cframe.scale delete all
    for {set t 0; set x 0} {$x <= $pixMax} {set t [expr $t + 1]; set x [expr $x + $pixPerSec]} {
	$w.cframe.scale create text $x $tickTallY -text [format "%3.1f" $t] -justify center -anchor s -font $MVFXVizAttr(scaleFont) -fill $MVFXVizAttr(scaleFGColor)
	$w.cframe.scale create line $x $tickTallY $x $MVFXVizAttr(scaleWinH) -fill $MVFXVizAttr(scaleFGColor) -width 1
	set x2 [expr $x+$pixPerSec/2]
	$w.cframe.scale create line $x2 $tickShortY $x2 $MVFXVizAttr(scaleWinH) -fill $MVFXVizAttr(scaleFGColor) -width 1
    }
}




# add a wave form of the sound (sndHdl) to the screen
# (at the bottom)
proc MVFXVizAddWaveform { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr

    # obtain the width of the waveform
    set waveformWidth [expr int($MVFXSndAttr($sndHdl,sec) * $MVFXVizAttr(dispPixelsPerSecond))]

    # update the display dimension (all scrollable)
    MVFXVizUpdateMainW $w $waveformWidth

    # generate a waveform and put it in
    $w.cframe.disp create waveform 0 0 -anchor nw \
	-fill $MVFXVizAttr(dispWaveformFillColor) \
	-height $MVFXVizAttr(dispWaveformHeightPixel) \
	-pixelspersecond $MVFXVizAttr(dispPixelsPerSecond) \
	-sound $sndHdl \
	-subsample $MVFXVizAttr(dispWaveformSubsample) \
	-tags "$sndHdl $sndHdl,waveform" \
	-frame 1

    ########################################
    # set command menu for this
    ########################################
    menu $w.mWaveform$sndHdl
    $w.mWaveform$sndHdl add command -label "play whole" \
	-command "MVFXSndPlayWhole $w $sndHdl"
    $w.mWaveform$sndHdl add command -label "show spectrogram" \
	-command "MVFXCmdShowSpectrogram $w $sndHdl"
    $w.mWaveform$sndHdl add command -label "show pitch" \
	-command "MVFXCmdShowPitch $w $sndHdl"
    $w.cframe.disp bind "$sndHdl,waveform" <3> "$w.mWaveform$sndHdl post %X %Y"
}



proc MVFXVizAddPanel { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr

    # obtain the width of the waveform
    set dirName [file dirname $MVFXSndAttr($sndHdl,filename)]
    set fileName [lindex [file split $MVFXSndAttr($sndHdl,filename)] end]

    # generate a panel for the wave object

    # the coordinate of the wavefile,
    # tentatively set to (0,0)
    set waveformCX 0
    set waveformCY 0
    $w.cframe.panel create text $waveformCX $waveformCY \
	-anchor nw \
	-text "$dirName\n$fileName" \
	-font $MVFXVizAttr(panelFont) \
        -fill $MVFXVizAttr(dispWaveformFillColor) \
	-tags "$sndHdl $sndHdl,panelFileName fname"
    
    set MVFXVizAttr(panelRight) [lindex [$w.cframe.panel bbox fname] 2]
    catch {$w.cframe.panel configure -scrollregion \
	       "$MVFXVizAttr(panelLeft) $MVFXVizAttr(panelTop) $MVFXVizAttr(panelRight) $MVFXVizAttr(panelBottom)"}
}



######################################################################
# CONTROLLER SECTION
######################################################################


proc MVFXCmdLoadSound { w {at "end"} } {
    set fileName [MVFXDialogChooseSoundFile $w]
    if {$fileName == "" } { return }
    $w configure -cursor watch 
    update
    set sndHdl [MVFXSndFromFile $fileName]
    MVFXVizAddWaveform $w $sndHdl
    MVFXVizAddPanel $w $sndHdl
    $w configure -cursor arrow
    update
}





######################################################################
# MODEL SECTION
######################################################################


########################################
# sound model management
########################################
set MVFXSndAttr(cnt) 0
set MVFXSndAttr(hdls) {}

# obtain a new sound handle; 
# all the handles are recorded in MVFXSndAttr(hdls) .


proc MVFXSndNew {} {
    global MVFXSndAttr
    set sndHdl "snd$MVFXSndAttr(cnt)"
    incr MVFXSndAttr(cnt)
    lappend MVFXSndAttr(hdls) $sndHdl
    return $sndHdl
}

proc MVFXSndFromFile { fileName } {
    global MVFXSysAttr MVFXSndAttr w
    set sndHdl [MVFXSndNew]
    snack::sound $sndHdl -load $fileName
    set MVFXSndAttr($sndHdl,filename) $fileName
    set MVFXSndAttr($sndHdl,sec) [$sndHdl length -unit SECONDS]
    return $sndHdl
}


proc MVFXSndPlayWhole { w sndHdl } {
    $sndHdl play 
# ?-start start? ?-end end? ?-output jack? ?-blocking boolean? -command ?callback? ?-device outputDevice? ?-devicerate rate? ?-devicechannels channels?
#    consPuts "not implemented yet"
}


proc MVFXCmdShowSpectrogram { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr
    $w.cframe.disp create spectrogram \
	0 $MVFXVizAttr(dispWaveformHeightPixel) -anchor nw \
	-fftlength $MVFXVizAttr(dispSpectrogramFFTLength) \
	-gridcolor $MVFXVizAttr(dispSpectrogramGridColor) \
	-height $MVFXVizAttr(dispSpectrogramHeightPixel) \
	-pixelspersecond $MVFXVizAttr(dispPixelsPerSecond) \
	-sound $sndHdl \
	-tags "$sndHdl $sndHdl,specrogram" \
	-topfrequency $MVFXVizAttr(dispSpectrogramTopFreq)


}

proc MVFXCmdShowPitch { w sndHdl } {
    consPuts "not implemented yet"
}


######################################################################
# Initialization
######################################################################

# draw the default horizontal scale
MVFXVizSetHorizScale $w
